﻿Imports System.ServiceModel.Description

' NOTE: If you change the class name "Service1" here, you must also update the reference to "Service1" in App.config.
Public Class Service1
    Implements IService1

    Public Function GetData(ByVal value As Integer) As String Implements IService1.GetData
        Return String.Format("You entered: {0}", value)
    End Function

    Public Function GetDataUsingDataContract(ByVal composite As CompositeType) As CompositeType Implements IService1.GetDataUsingDataContract
        If composite.BoolValue Then
            composite.StringValue = (composite.StringValue & "Suffix")
        End If
        Return composite
    End Function

End Class

' Copyright (c) Microsoft Corporation. All rights reserved.




<Serializable()> _
<DurableService()> _
Public Class DurableCalculator
    Implements ICalculator
    Private currentValue As Integer = Nothing

    <DurableOperation(CanCreateInstance:=True)> _
    Public Function PowerOn() As Integer Implements ICalculator.PowerOn
        Return currentValue
    End Function

    <DurableOperation()> _
    Public Function Add(ByVal value As Integer) As Integer Implements ICalculator.Add
        currentValue += value
        Return (currentValue)
    End Function

    <DurableOperation()> _
    Public Function Subtract(ByVal value As Integer) As Integer Implements ICalculator.Subtract
        currentValue -= value
        Return (currentValue)
    End Function

    <DurableOperation()> _
    Public Function Multiply(ByVal value As Integer) As Integer Implements ICalculator.Multiply
        currentValue *= value
        Return (currentValue)
    End Function

    <DurableOperation()> _
    Public Function Divide(ByVal value As Integer) As Integer Implements ICalculator.Divide
        currentValue /= value
        Return (currentValue)
    End Function

    <DurableOperation(CompletesInstance:=True)> _
    Public Sub PowerOff() Implements ICalculator.PowerOff
    End Sub

End Class

