using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Compensation
{
    [DataContract]
    public class MyData
    {
        [DataMember]
        public string MyDataMember;
    }

    [ServiceContract(SessionMode=SessionMode.Required)]
    [DeliveryRequirements(QueuedDeliveryRequirements 
        = QueuedDeliveryRequirementsMode.Required)]
    public interface IMyServiceContract
    {
        [OperationContract(IsOneWay=true,IsInitiating=true)]
        void FirstOperation(string input);
        [OperationContract(IsOneWay = true,IsTerminating=true)]
        void SecondOperation(string input);
    }

    public class MyClient : ClientBase<IMyServiceContract>, IMyServiceContract
    {
        public MyClient(string endpointConfigurationName)
            : base(endpointConfigurationName)
        {
        }
        
        public void FirstOperation(string input)
        {
            base.Channel.FirstOperation(input);
        }

        public void SecondOperation(string input)
        {
            base.Channel.SecondOperation(input);
        }

    }
}
