using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Messaging;
using System.Text;

namespace Compensation
{
    class Program
    {
        private const string serviceQueueName = @".\private$\MyService";
        private const string targetQueueName = @".\private$\MyTarget";
        private const string compensationQueueName = @".\private$\MyCompensator";

        public static void Main(string[] args)
        {
            if (!(MessageQueue.Exists(serviceQueueName)))
            {
                MessageQueue.Create(serviceQueueName, true);
            }

            if (!(MessageQueue.Exists(targetQueueName)))
            {
                MessageQueue.Create(targetQueueName, true);
            }

            if (!(MessageQueue.Exists(compensationQueueName)))
            {
                MessageQueue.Create(compensationQueueName, true);
            }

            using (ServiceHost host = new ServiceHost(typeof(MyService)))
            {
                host.Open();

                Console.WriteLine("The receiving service is available.");
                Console.ReadKey(true);

                host.Close();

            }

            
           

        }
    }
}
