﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.Xml;

namespace OrderProcessing
{
    [ServiceContract(Namespace ="http://microsoft.com/dpe/samples/duplex")]
	public interface  IOrderProcessing
	{
        [OperationContract()]
        void SubmitOrder(string customerName, IDictionary<string, string> context);

        [OperationContract(IsOneWay = true )]
        void AddItem(OrderItem orderItem);

        [OperationContract(IsOneWay = true )]
        void CompleteOrder();
	}


    [ServiceContract(Namespace = "http://microsoft.com/dpe/samples/duplex")]
    public interface IUpdateShippingCost
    {
        [OperationContract(IsOneWay = true)]
        void SendShippingCost(int shippingCost);
    }

    
    

    [DataContract(Namespace = "http://microsoft.com/dpe/samples/duplex")]
    public class OrderItem 
    {
        [DataMember]
        public string ItemNumber { get; set; }
        [DataMember]
        public int ItemQuantity { get; set; }
    }
}
