﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;

namespace OrderSubmitter
{
    class Program
    {
        static void Main(string[] args)
        {
            using (WorkflowServiceHost wsh = new WorkflowServiceHost(typeof(Workflow1)))
            {
                Console.WriteLine("Press <ENTER> to start the workflow");
                Console.ReadLine();
                wsh.Open();
                WorkflowRuntime wr = wsh.Description.Behaviors.Find<WorkflowRuntimeBehavior>().WorkflowRuntime;
                WorkflowInstance wi = wr.CreateWorkflow(typeof(Workflow1));
                AutoResetEvent waitHandle = new AutoResetEvent(false);
                wr.WorkflowCompleted += delegate { waitHandle.Set(); };
                wr.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e) { Console.WriteLine("error {0}", e); waitHandle.Set(); };
                wi.Start();
                waitHandle.WaitOne();
                Console.WriteLine("Workflow Completed");
                Console.ReadLine();
            }
        }
    }
}
