﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.Text;
using System.Xml;

namespace Long_Running_Work
{

  //  [ServiceBehavior(ConcurrencyMode=ConcurrencyMode.Multiple)]
   public class Service1 : ILongRunningWork
    {

        public Service1()
        {
           // Console.WriteLine("Created!");
        }

        #region ILongRunningWork Members

        public string TakeAWhile(int i)
        {
            Console.WriteLine("Starting TakeAWhile");
            System.Threading.Thread.Sleep(new TimeSpan(0, 0, 3));
            return i.ToString();
        }



        public void OneWayTakeAWhile( int i)
        {
            Console.WriteLine("Starting One Way TakeAWhile");
            System.Threading.Thread.Sleep(new TimeSpan(0, 0, 3));
            Console.WriteLine("Ending One Way TakeAWhile");


        }


        public void TakeAWhileAndTellMeLater(IDictionary<XmlQualifiedName, string> context, int i)
        {
            Console.WriteLine("Received the context Token");
            System.Threading.Thread.Sleep(new TimeSpan(0, 0, 3));
            Console.WriteLine("Need to Message Back Now {0}", i.ToString());
            IReverseContractClient ircc = new IReverseContractClient(
                new NetTcpContextBinding(),
                new EndpointAddress("net.tcp://localhost:10003/ReverseContract")
                );
            IContextManager icm = ircc.InnerChannel.GetProperty<IContextManager>();
            icm.SetContext(context);
            ircc.TakeAWhileAndTellMeLaterDone(i.ToString());
        }



        #endregion
    }

   public class IReverseContractClient : ClientBase<IReverseContract>, IReverseContract
   {
        public IReverseContractClient() : base(){}
        public IReverseContractClient(System.ServiceModel.Channels.Binding binding, EndpointAddress address) : base(binding, address) { }

#region IReverseContract Members



       public void TakeAWhileAndTellMeLaterDone(string s)
       {
           base.Channel.TakeAWhileAndTellMeLaterDone(s);
       }

       #endregion
   }
 
}
