﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Workflow;
using System.Workflow.Activities;
using System.Workflow.ComponentModel;
using System.Workflow.Runtime;
using System.Threading;

namespace WorkflowHost
{
    class Program
    {
        static void Main(string[] args)
        {
            AutoResetEvent waitHandle = new AutoResetEvent(false);


            Console.WriteLine("Hit enter to execute in Workflow Service Host");
            Console.ReadLine();
            
            using (WorkflowServiceHost wsh = new WorkflowServiceHost(typeof(CallLongRunningComponents.WorkflowWithmessaging)))
            {
                wsh.AddServiceEndpoint(
                        typeof(Long_Running_Work.IReverseContract),
                        new NetTcpContextBinding(), 
                       "net.tcp://localhost:10003/ReverseContract"
                        );

                WorkflowRuntime wr = wsh.Description.Behaviors.Find<WorkflowRuntimeBehavior>().WorkflowRuntime;

                wr.AddService(new System.Workflow.Runtime.Hosting.SqlWorkflowPersistenceService(@"Data Source=MWINKLE-M400XP\SQLEXPRESS;Initial Catalog=DinnerNowWF;Integrated Security=True"));
                
                
                // don't forget to open up the wsh

                wsh.Open();


                WorkflowInstance wi = wr.CreateWorkflow(typeof(CallLongRunningComponents.WorkflowWithmessaging));
                wr.WorkflowCompleted += delegate(object o, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
                wr.WorkflowIdled += delegate(object o, WorkflowEventArgs e) { Console.WriteLine("Now we're idled"); };
                wr.WorkflowPersisted += delegate(object o, WorkflowEventArgs e) {Console.WriteLine("We persisted"); };
                wi.Start();




                waitHandle.WaitOne();

            }

            Console.WriteLine("All Done, press <enter> to exit");
            Console.ReadLine();
            
        }
    }
}
