﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Workflow;
using System.Workflow.Activities;
using System.Workflow.ComponentModel;
using System.Workflow.Runtime;
using System.Threading;

namespace WorkflowHost
{
    class Program
    {
        static void Main(string[] args)
        {
            AutoResetEvent waitHandle = new AutoResetEvent(false);
            Console.WriteLine("Press Enter to Start it up");
            Console.ReadLine();
            using ( WorkflowRuntime wr = new WorkflowRuntime())
            {
                wr.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
                WorkflowInstance wi = wr.CreateWorkflow(typeof(CallLongRunningComponents.Workflow1));
                wi.Start();
                waitHandle.WaitOne();
               
            }

            Console.WriteLine("Hit enter to execute in Workflow Service Host");
            Console.ReadLine();
            Console.WriteLine("Now executing inside the WorkflowServiceHost");
            
            using (WorkflowServiceHost wsh = new WorkflowServiceHost(typeof(CallLongRunningComponents.WorkflowWithmessaging)))
            {
                wsh.AddServiceEndpoint(
                        typeof(Long_Running_Work.IReverseContract),
                        new NetTcpContextBinding(), 
                       "net.tcp://localhost:10003/ReverseContract"
                        );
                // don't forget to open up the wsh

                wsh.Open();


                WorkflowRuntime wr = wsh.Description.Behaviors.Find<WorkflowRuntimeBehavior>().WorkflowRuntime;
                WorkflowInstance wi = wr.CreateWorkflow(typeof(CallLongRunningComponents.WorkflowWithmessaging));
                wr.WorkflowCompleted += delegate(object o, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
                wr.WorkflowIdled += delegate(object o, WorkflowEventArgs e) { Console.WriteLine("Now we're idled"); };
                
                wi.Start();




                waitHandle.WaitOne();

            }

            Console.WriteLine("All Done, press <enter> to exit");
            Console.ReadLine();
            
        }
    }
}
