﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace SimpleServiceHost
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ServiceHost sh = new ServiceHost(typeof(Long_Running_Work.Service1)))
            {
                sh.AddServiceEndpoint(typeof(Long_Running_Work.ILongRunningWork),
                                        new BasicHttpBinding(),
                                        "http://localhost:10002/LongRunningWork.svc");
                ServiceMetadataBehavior smb = new ServiceMetadataBehavior();
                smb.HttpGetEnabled = true;
                smb.HttpGetUrl = new Uri("http://localhost:10002/LongRunningWork.svc");
                sh.Description.Behaviors.Add(smb);
                sh.Open();
                Console.WriteLine("Service is open for business");
                Console.WriteLine("Press <Enter> to Exit");
                Console.ReadLine();
                sh.Close();
            }

        }
    }
}
