﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Workflow;
using System.Workflow.Activities;
using System.Workflow.ComponentModel;
using System.Workflow.Runtime;
using System.Threading;
using System.ServiceModel.Channels;
using System.Diagnostics;

namespace WorkflowHost
{
    class Program
    {

        static AutoResetEvent waitHandle = new AutoResetEvent(false);
        static bool areDone = false;

        static void Main(string[] args)
        {
            AutoResetEvent waitHandle = new AutoResetEvent(false);
            Console.WriteLine("Press Enter to Start it up");
            Console.ReadLine();
            using (WorkflowRuntime wr = new WorkflowRuntime())
            {
                wr.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
                WorkflowInstance wi = wr.CreateWorkflow(typeof(CallLongRunningComponents.Workflow1));
                wi.Start();
                waitHandle.WaitOne();

            }

            Console.WriteLine("Hit enter to execute in Workflow Service Host");
            Console.ReadLine();
            Console.WriteLine("Now executing inside the WorkflowServiceHost");

            using (WorkflowServiceHost wsh = new WorkflowServiceHost(typeof(CallLongRunningComponents.WorkflowWithmessaging)))
            {
                wsh.AddServiceEndpoint(
                        typeof(Long_Running_Work.IReverseContract),
                        new NetTcpContextBinding(),
                       "net.tcp://localhost:10003/ReverseContract"
                        );
                // don't forget to open up the wsh
                WorkflowRuntime wr = wsh.Description.Behaviors.Find<WorkflowRuntimeBehavior>().WorkflowRuntime;

                wsh.Open();


                WorkflowInstance wi = wr.CreateWorkflow(typeof(CallLongRunningComponents.WorkflowWithmessaging));
                wr.WorkflowCompleted += delegate(object o, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
                wr.WorkflowIdled += delegate(object o, WorkflowEventArgs e) { Console.WriteLine("Now we're idled"); };

                wi.Start();




                waitHandle.WaitOne();

            }

            Console.WriteLine("Press <enter> to execute APM approach");
            Console.ReadLine();
            waitHandle = new AutoResetEvent(false);
            Stopwatch sw = new Stopwatch();
            sw.Start();
            lrwc = new WorkflowHost.ServiceReference1.LongRunningWorkClient();
            lrwc.BeginTakeAWhile(1, HandleClientReturn, "one");
            lrwc.BeginTakeAWhile(2, HandleClientReturn, "two");
            lrwc.BeginTakeAWhile(3, HandleClientReturn, "three");
            lrwc.BeginTakeAWhile(4, HandleClientReturn, "four");
            while (!areDone)
            {
                System.Threading.Thread.Sleep(25);
            }
            Console.WriteLine("APM approach compelted in {0} milliseconds", sw.ElapsedMilliseconds);
            Console.WriteLine("All Done, press <enter> to exit");
            Console.ReadLine();

        }


        static ServiceReference1.LongRunningWorkClient lrwc;
        static Int32 countOfFinished = 0;

        static void HandleClientReturn(IAsyncResult result)
        {
            string s = (string)result.AsyncState;
            string resultString = lrwc.EndTakeAWhile(result);
            Console.WriteLine("received {0}", resultString);
            if (Interlocked.Increment(ref countOfFinished) == 4)
            {
                areDone = true;
            }



        }
    }



}
