using System;
using System.Collections.Generic;
using System.Configuration;
using System.ServiceModel.Configuration;
using System.Text;

namespace Extensibility
{
    public class MyBehaviorExtensionElement: BehaviorExtensionElement
    {
        private ConfigurationPropertyCollection properties = null;

        [ConfigurationProperty("myProperty", DefaultValue = "", IsRequired = true)]
        public string MyProperty
        {
            get 
            {
                return (string)base["myProperty"]; 
            }

            set 
            {
                base["myProperty"] = value; 
            }
        }

        public override Type BehaviorType
        {
            get 
            {
                return typeof(MyMessageInspector);
            }
        }

        protected override object CreateBehavior()
        {
            return new MyMessageInspector(this.MyProperty);
        }

        protected override ConfigurationPropertyCollection Properties 
        { 
            get 
            { 
                if(this.properties == null) 
                { 
                    this.properties = new ConfigurationPropertyCollection(); 
                    this.properties.Add(
                        new ConfigurationProperty(
                            "myProperty", 
                            typeof(string), 
                            "", 
                            ConfigurationPropertyOptions.IsRequired)); 
                } 
                return properties; 
            } 
        }

        public override void CopyFrom(ServiceModelExtensionElement from)
        {
            base.CopyFrom(from);

            MyBehaviorExtensionElement element = (MyBehaviorExtensionElement)from;
            this.MyProperty = element.MyProperty;
        }
    }
}
