using System;
using System.Collections.Generic;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace Extensibility
{
	public class MyMessageFormatter: IDispatchMessageFormatter, IOperationBehavior
	{
		IDispatchMessageFormatter defaultFormatter = null;

		#region IOperationBehavior Members

		public void AddBindingParameters(OperationDescription description, System.ServiceModel.Channels.BindingParameterCollection parameters)
		{
		}

		public void ApplyClientBehavior(OperationDescription description, ClientOperation proxy)
		{
			
		}

		public void ApplyDispatchBehavior(OperationDescription description, DispatchOperation dispatch)
		{
			this.defaultFormatter = dispatch.Formatter;
			dispatch.Formatter = this;
		}

		public void Validate(OperationDescription description)
		{
		}

		#endregion



		#region IDispatchFormatter Members

		public void DeserializeRequest(System.ServiceModel.Channels.Message message, object[] parameters)
		{
			Console.WriteLine("I am playing games with how the request message is deserialized.");
			Console.WriteLine("Before deserializing, the value of the parameter is null: true or false? {0}", parameters[0] == null);
			this.defaultFormatter.DeserializeRequest(message, parameters);
			Console.WriteLine("After deserializing, the value of the parameter is {0}", parameters[0].ToString());
		}

		public System.ServiceModel.Channels.Message SerializeReply(System.ServiceModel.Channels.MessageVersion messageVersion, object[] parameters, object result)
		{
			Console.WriteLine("I am playing games with how the response message is serialized.");
			return this.defaultFormatter.SerializeReply(messageVersion, parameters, result);
		}

		#endregion
	}
}
