using System;
using System.Collections.Generic;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace Extensibility
{
	public class MyOperationInvoker: IOperationInvoker, IOperationBehavior
	{
		IOperationInvoker defaultInvoker = null;

		#region IOperationBehavior Members

		public void AddBindingParameters(OperationDescription description, System.ServiceModel.Channels.BindingParameterCollection parameters)
		{
		}

		public void ApplyClientBehavior(OperationDescription description, ClientOperation proxy)
		{
		}

		public void ApplyDispatchBehavior(OperationDescription description, DispatchOperation dispatch)
		{
			this.defaultInvoker = dispatch.Invoker;
			dispatch.Invoker = this;
		}

		public void Validate(OperationDescription description)
		{
		}

		#endregion

		#region IOperationInvoker Members

		public object[] AllocateInputs()
		{
			return this.defaultInvoker.AllocateInputs();
		}

		public object Invoke(object instance, object[] inputs, out object[] outputs)
		{
			Console.WriteLine("I am playing games at the point at which a method of the service type is invoked.");
			return this.defaultInvoker.Invoke(instance, inputs, out outputs);
		}

		public IAsyncResult InvokeBegin(object instance, object[] inputs, AsyncCallback callback, object state)
		{
			return this.defaultInvoker.InvokeBegin(instance, inputs, callback, state);
		}

		public object InvokeEnd(object instance, out object[] outputs, IAsyncResult result)
		{
			return this.defaultInvoker.InvokeEnd(instance,out outputs,result);
		}

		public bool IsSynchronous
		{
			get 
			{ 
				return this.defaultInvoker.IsSynchronous; 
			}
		}

		#endregion
	}
}
