using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Extensibility
{
	class MyCustomOutputChannel : CustomChannelBase<IOutputChannel>, IOutputChannel
	{
		public MyCustomOutputChannel(ChannelManagerBase factory, IOutputChannel innerChannel): base(factory, innerChannel)
		{
			// empty
		}

		public EndpointAddress RemoteAddress
		{
			get
			{
				return this.InnerChannel.RemoteAddress;
			}
		}

		public Uri Via
		{
			get
			{
				return this.InnerChannel.Via;
			}
		}

		public IAsyncResult BeginSend(Message message, AsyncCallback callback, object state)
		{
			this.OnSend(message);
			return this.InnerChannel.BeginSend(message, callback, state);
		}

		public IAsyncResult BeginSend(Message message, TimeSpan timeout, AsyncCallback callback, object state)
		{
			this.OnSend(message);
			return this.InnerChannel.BeginSend(message, timeout, callback, state);
		}

		public void EndSend(IAsyncResult result)
		{
			this.InnerChannel.EndSend(result);
		}

		public void Send(Message message)
		{
			this.OnSend(message);
			this.InnerChannel.Send(message);
		}

		public void Send(Message message, TimeSpan timeout)
		{
			this.OnSend(message);
			this.InnerChannel.Send(message, timeout);
		}
	}
}
