using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Extensibility
{
	class MyCustomInputChannel : CustomChannelBase<IInputChannel>, IInputChannel
	{
		public MyCustomInputChannel(ChannelManagerBase manager, IInputChannel innerChannel): base(manager, innerChannel)
		{
			// empty
		}

		public EndpointAddress LocalAddress
		{
			get
			{
				return this.InnerChannel.LocalAddress;
			}
		}

		public Message Receive()
		{
			Message message = this.InnerChannel.Receive();
			this.OnReceive(message);
			return message;
		}

		public Message Receive(TimeSpan timeout)
		{
			Message message = this.InnerChannel.Receive(timeout);
			this.OnReceive(message);
			return message;
		}

		public IAsyncResult BeginReceive(AsyncCallback callback, object state)
		{
			return this.InnerChannel.BeginReceive(callback, state);
		}

		public IAsyncResult BeginReceive(TimeSpan timeout, AsyncCallback callback, object state)
		{
			return this.InnerChannel.BeginReceive(timeout, callback, state);
		}

		public Message EndReceive(IAsyncResult result)
		{
			Message message = this.InnerChannel.EndReceive(result);
			this.OnReceive(message);
			return message;
		}

		public bool TryReceive(TimeSpan timeout, out Message message)
		{
			if (this.InnerChannel.TryReceive(timeout, out message))
			{
				this.OnReceive(message);
				return true;
			}
			else
			{
				return false;
			}
		}

		public IAsyncResult BeginTryReceive(TimeSpan timeout, AsyncCallback callback, object state)
		{
			return this.InnerChannel.BeginTryReceive(timeout, callback, state);
		}

		public bool EndTryReceive(IAsyncResult result, out Message message)
		{
			if (this.InnerChannel.EndTryReceive(result, out message))
			{
				this.OnReceive(message);
				return true;
			}
			else
			{
				return false;
			}
		}

		public bool WaitForMessage(TimeSpan timeout)
		{
			return this.InnerChannel.WaitForMessage(timeout);
		}

		public IAsyncResult BeginWaitForMessage(TimeSpan timeout, AsyncCallback callback, object state)
		{
			return this.InnerChannel.BeginWaitForMessage(timeout, callback, state);
		}

		public bool EndWaitForMessage(IAsyncResult result)
		{
			return this.InnerChannel.EndWaitForMessage(result);
		}
	}

}
