using System;
using System.ServiceModel;
using System.ServiceModel.Channels;


namespace Extensibility
{
    public class MyCustomMessageEncoderBindingElement : MessageEncodingBindingElement
    {
        MessageVersion version = MessageVersion.None;

        public MyCustomMessageEncoderBindingElement()
        {
        }

        public MyCustomMessageEncoderBindingElement(MyCustomMessageEncoderBindingElement other)
        {
            this.version = other.version;
        }

        

        public override MessageEncoderFactory CreateMessageEncoderFactory()
        {
            return new MyCustomMessageEncoderFactory(this);
        }

        public override MessageVersion MessageVersion
        {
            get
            {
                return this.version;
            }
            set
            {
                this.version = value;
            }
        }

        public override BindingElement Clone()
        {
            return new MyCustomMessageEncoderBindingElement(this);
        }

        public override IChannelFactory<TChannel> BuildChannelFactory<TChannel>(BindingContext context)
        {
            context.BindingParameters.Add(this);
            return context.BuildInnerChannelFactory<TChannel>();
        }

        public override bool CanBuildChannelFactory<TChannel>(BindingContext context)
        {
            return context.CanBuildInnerChannelFactory<TChannel>();
        }

        public override IChannelListener<TChannel> BuildChannelListener<TChannel>(BindingContext context)
        {
            context.BindingParameters.Add(this);
            return context.BuildInnerChannelListener<TChannel>();
        }

        public override bool CanBuildChannelListener<TChannel>(BindingContext context)
        {
            context.BindingParameters.Add(this);
            return context.CanBuildInnerChannelListener<TChannel>();
        }
    }
}
