using System;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace Extensibility
{
    public class MyCustomMessageEncoderFactory : MessageEncoderFactory
    {
        private MyCustomMessageEncoder encoder = null;
        private MessageVersion version = null;

        private MyCustomMessageEncoderFactory()
        {
        }

        public MyCustomMessageEncoderFactory(MyCustomMessageEncoderBindingElement bindingElement)
        {
            this.version = bindingElement.MessageVersion;
        }

        public override MessageEncoder Encoder
        {
            get 
            {
                if (this.encoder == null)
                {
                    this.encoder = new MyCustomMessageEncoder(this);
                }

                return this.encoder;
            }
        }

        public override MessageVersion MessageVersion
        {
            get 
            {
                return this.version;
            }
        }
    }
}
