using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Client
{
	[ServiceContract]
	public interface IPictureServer
	{
		[OperationContract]
		Stream GetPicture(string pictureName);
	}

    public class PictureClient : ClientBase<IPictureServer>, IPictureServer
    {
        public PictureClient(string endpointConfigurationName)
            : base(endpointConfigurationName)
        {
        }

        public Stream GetPicture(string pictureName)
        {
            return base.Channel.GetPicture(pictureName);
        }
    }


	class Program
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Press any key when the service is available.");
			Console.ReadKey();

			byte[] buffer = new byte[1024];

			PictureClient pictureClient = new PictureClient("PictureServer");
			Stream pictureStream = pictureClient.GetPicture("Pony.jpg");
			while (pictureStream.Read(buffer, 0, 1024) > 0)
			{
				Console.WriteLine("Reading");
			}
            Console.WriteLine("Done");


            pictureClient.Close();

			Console.ReadKey();


		}
	}
}
