using System;
using System.Collections.Generic;
using System.Text;

namespace PublicationSubscription
{
	public class DataPoint: IDataPoint
	{
		public event NextValueHandler NextValue = null;

		private string name = null;
		private string description = null;

		private DataPoint()
		{
		}

		public DataPoint(string name, string description)
		{
			this.name = name;
			this.description = description;
		}

		protected void RaiseNextValueEvent(IDataPoint sender, byte[] newValue)
		{
			if (this.NextValue != null)
			{
				this.NextValue(sender, newValue);
			}
		}


		#region IDataPoint Members

		string IDataPoint.Name
		{
			get 
			{ 
				return this.name; 
			}
		}

		string IDataPoint.Description
		{
			get
			{
				return this.description;
			}
		}

		Guid IDataPoint.Identifier
		{
			get
			{
				return this.GetType().GUID;
			}
		}


		#endregion
}
}
