using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.ServiceModel;
using System.Text;

namespace Service
{
	[ServiceContract]
	public interface IPictureServer
	{
		[OperationContract]
		Stream GetPicture(string pictureName);


	}

	internal class PictureServer: IPictureServer
	{
		
		#region IPictureServer Members

		Stream IPictureServer.GetPicture(string pictureName)
		{

			try
			{
				CustomStream customStream = new CustomStream(pictureName);
				return customStream;
				
			}
			catch (Exception)
			{
				return null;
			}
			
		}

		
		

		#endregion
}
	
	public class Program
	{
		static void Main(string[] args)
		{
			using (ServiceHost host = new ServiceHost(typeof(PictureServer)))
			{
				host.Open();

				Console.WriteLine(string.Format("The service is available at {0}.  Press any key to terminate the service.  ", host.Description.Endpoints[0].Address.Uri.AbsoluteUri));

				Console.ReadKey();
			}
		}
	}
}
