using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Configuration;
using System.IO;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.Text;
using System.Xml;

namespace DerivativesCalculator
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Type serviceType = typeof(DerivativesCalculatorServiceType);

            using (ServiceHost host = new ServiceHost(
                serviceType,
                new Uri[] { new Uri("http://localhost:8000/Derivatives/")}
                ))
            {
                Collection<Binding> bindings = new WsdlImporter(MetadataSet.ReadFrom(new XmlTextReader(new FileStream("metadata.xml", FileMode.Open)))).ImportAllBindings();
                int index = 0;
                foreach (Binding binding in bindings)
                {
                    host.AddServiceEndpoint(typeof(IDerivativesCalculator), binding, string.Format("Calculator{0}",index++));
                }

                ServiceMetadataBehavior metadataBehavior = new ServiceMetadataBehavior();
                metadataBehavior.HttpGetEnabled = true;
                host.Description.Behaviors.Add(metadataBehavior);
                host.Open();

                Console.WriteLine(
                    "The derivatives calculator service is available."
                );
                Console.ReadKey(true);

                host.Close();
            }
        }

        

        
    }

    

}
